'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

var PASSIVE_EVENT_LISTENERS = ['touchstart'];

exports.default = function () {
  var classNames = [];

  return {
    addClass: function addClass(updateClassNames) {
      return function (className) {
        classNames = [].concat(_toConsumableArray(classNames), [className]);
        updateClassNames(classNames);
      };
    },
    deregisterInteractionHandler: function deregisterInteractionHandler(element) {
      return function (type, handler) {
        return element.removeEventListener(type, handler);
      };
    },
    getWidth: function getWidth(element) {
      return function () {
        return element.offsetWidth;
      };
    },
    registerInteractionHandler: function registerInteractionHandler(element) {
      return function (type, handler) {
        return element.addEventListener(type, handler, PASSIVE_EVENT_LISTENERS.includes(type) ? { passive: true } : null);
      };
    },
    removeClass: function removeClass(updateClassNames) {
      return function (className) {
        classNames = classNames.filter(function (currentClassName) {
          return currentClassName !== className;
        });
        updateClassNames(classNames);
      };
    }
  };
};