'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _floatingLabel = require('@material/floating-label');

var _adapterUtilities2 = require('./adapter-utilities');

var _adapterUtilities3 = _interopRequireDefault(_adapterUtilities2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (_ref) {
  var elementRoot = _ref.elementRoot,
      updateClassNames = _ref.updateClassNames;

  var _adapterUtilities = (0, _adapterUtilities3.default)(),
      addClass = _adapterUtilities.addClass,
      deregisterInteractionHandler = _adapterUtilities.deregisterInteractionHandler,
      getWidth = _adapterUtilities.getWidth,
      registerInteractionHandler = _adapterUtilities.registerInteractionHandler,
      removeClass = _adapterUtilities.removeClass;

  return new _floatingLabel.MDCFloatingLabelFoundation({
    addClass: addClass(updateClassNames),
    deregisterInteractionHandler: deregisterInteractionHandler(elementRoot),
    getWidth: getWidth(elementRoot),
    registerInteractionHandler: registerInteractionHandler(elementRoot),
    removeClass: removeClass(updateClassNames)
  });
};